﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class PlayerController : MonoBehaviour
{
    private float speed = 0.1f;
    private AudioSource audios;

    public AudioClip[] audioClips;
    public KeyCode up, down, left, right, skill1, skill2, skill3, skill4;
    public int health = 5, pos = 0;
    public GameObject bullet1, bullet2, bullet3, bullet4;
    public GameObject bulletsContainer;
    public Text healthText;
    public Animator playerAnim;

    // Start is called before the first frame update
    void Start()
    {
        audios = this.transform.GetComponent<AudioSource>();
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKeyDown(up))
        {
            this.GetComponent<Rigidbody2D>().AddForce(Vector3.up * 320);
        }
        if (Input.GetKeyDown(down))
        {
            this.GetComponent<Rigidbody2D>().AddForce(Vector3.down * 100);
        }
        if (Input.GetKey(left))
        {
            this.transform.position = new Vector3(this.transform.position.x - speed, this.transform.position.y, -0.1f);
            pos = 0;
        }
        if (Input.GetKey(right))
        {
            this.transform.position = new Vector3(this.transform.position.x + speed, this.transform.position.y, -0.1f);
            pos = 1;
        }
        if (Input.GetKeyDown(skill1))
        {
            audios.PlayOneShot(audioClips[0]);
            GameObject newBullet1 = Instantiate(bullet1);
            newBullet1.transform.parent = bulletsContainer.transform;
            newBullet1.transform.position = this.transform.position;
            newBullet1.GetComponent<BulletController>().SetPos(pos);
        }
        if (Input.GetKeyDown(skill2))
        {
            audios.PlayOneShot(audioClips[1]);
            GameObject newBullet1 = Instantiate(bullet2);
            newBullet1.transform.parent = bulletsContainer.transform;
            newBullet1.transform.position = this.transform.position;
            newBullet1.GetComponent<BulletController>().SetPos(pos);
        }
        if (Input.GetKeyDown(skill3))
        {
            audios.PlayOneShot(audioClips[2]);
            GameObject newBullet1 = Instantiate(bullet3);
            newBullet1.transform.parent = bulletsContainer.transform;
            newBullet1.transform.position = this.transform.position;
            newBullet1.GetComponent<BulletController>().SetPos(pos);
        }
        if (Input.GetKeyDown(skill4))
        {
            audios.PlayOneShot(audioClips[3]);
            GameObject newBullet1 = Instantiate(bullet4);
            newBullet1.transform.parent = bulletsContainer.transform;
            newBullet1.transform.position = this.transform.position;
            newBullet1.GetComponent<BulletController>().SetPos(pos);
        }
    }

    public int DecreaseHealth()
    {
        if(this.health >= 1) {
            this.health -= 1;
            healthText.text = healthText.text.Substring(0, 4) + health;
        }
        if(this.health <= 0)
        {
            Debug.Log("Player Dead");
            Destroy(this.gameObject);
            if (this.transform.name == "PlayerW-1")
            {
                return 0;
            }
            else if (this.transform.name == "PlayerM-1")
            {
                return 1;
            }
        }
        return -1;
    }
}
