﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class SafezoneRandomer : MonoBehaviour
{
    public GameObject[] safeZones;
    public GameObject boss, playerW, playerM;
    public Text timeCountDown;
    public Animator gameoverAnim;

    private int pos, count;
    private bool notGen, startTimer, nextStage;
    private float timer, subTimer, timerForNextStage;
    private GameObject safeZone = null;

    // Start is called before the first frame update
    void Start()
    {
        Physics2D.IgnoreLayerCollision(10, 12);
        Physics2D.IgnoreLayerCollision(10, 13);
        Physics2D.IgnoreLayerCollision(12, 13);
        Physics2D.IgnoreLayerCollision(11, 13);
        Physics2D.IgnoreLayerCollision(8, 13);
        Physics2D.IgnoreLayerCollision(10, 14);
        notGen = true;
        timer = 0;
        subTimer = 0;
        timerForNextStage = 0;
        count = 10;
        timeCountDown.enabled = false;
    }

    // Update is called once per frame
    void Update()
    {
        if (boss != null && boss.GetComponent<SunnyController>().IsDead() && notGen)
        {
            safeZone = Instantiate(safeZones[Random.Range(0, safeZones.Length - 1)]);
            //safeZone = Instantiate(safeZones[0]);
            startTimer = true;
            notGen = false;
            timeCountDown.enabled = true;
            Debug.Log("boss dead animate");
            DestroyImmediate(boss.gameObject);
            this.boss = null;
        }
        if (startTimer)
        {
            timer += Time.deltaTime;
            subTimer += Time.deltaTime;
            if(subTimer > 1)
            {
                if(count >= 1)
                {
                    count -= 1;
                }
                timeCountDown.text = count.ToString();
                subTimer = 0;
            }
        }
        if (timer > 12 && !nextStage)
        {
            Debug.Log("remove items");
            gameoverAnim.SetTrigger("gameOver");
        }
        if (playerW != null && playerM == null && safeZone != null && playerW.transform.position.x >= safeZone.transform.position.x - 1.5 && playerW.transform.position.x <= safeZone.transform.position.x + 1.5
            && playerW.transform.position.y >= safeZone.transform.position.y - 1.5 && playerW.transform.position.x <= safeZone.transform.position.y + 1.5)
        {
            Debug.Log("W in");
            timerForNextStage += Time.deltaTime;
            if (timerForNextStage > 2)
            {
                Debug.Log("next stage");
                nextStage = true;
                SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex + 1);
            }
        }
        else if ((playerW == null && playerM != null && safeZone != null && playerM.transform.position.x >= safeZone.transform.position.x - 1.5 && playerM.transform.position.x <= safeZone.transform.position.x + 2
            && playerM.transform.position.y >= safeZone.transform.position.y - 1.5 && playerM.transform.position.x <= safeZone.transform.position.y + 1.5))
        {
            Debug.Log("M in");
            timerForNextStage += Time.deltaTime;
            if (timerForNextStage > 2)
            {
                Debug.Log("next stage");
                nextStage = true;
                SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex + 1);
            }
        }
        else if(playerW != null && playerM != null && safeZone != null && playerW.transform.position.x >= safeZone.transform.position.x - 1.5 && playerW.transform.position.x <= safeZone.transform.position.x + 1.5
            && playerW.transform.position.y >= safeZone.transform.position.y - 1.5 && playerW.transform.position.x <= safeZone.transform.position.y + 1.5 && playerM.transform.position.x >= safeZone.transform.position.x - 1.5 && playerM.transform.position.x <= safeZone.transform.position.x + 2
            && playerM.transform.position.y >= safeZone.transform.position.y - 1.5 && playerM.transform.position.x <= safeZone.transform.position.y + 1.5)
        {
            Debug.Log("hi");
            timerForNextStage += Time.deltaTime;
            if(timerForNextStage > 2)
            {
                Debug.Log("next stage");
                nextStage = true;
                SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex + 1);
            }
        }
    }
}
