﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SunnyController : MonoBehaviour
{
    private float timer, subtimer;
    private int count;
    private GameObject[] players;
    private bool isDead, isWin;
    private int damage = 1, deadCount;

    public int health = 30;
    public Animator gameoverAnim;
    public SafezoneRandomer safezoneRandomer;
    public int hardLevel;

    // Start is called before the first frame update
    void Start()
    {
        timer = 0;
        deadCount = 0;
        count = 0;

        isDead = false;
        isWin = false;
        players = GameObject.FindGameObjectsWithTag("Player1");
        if (players != null) Debug.Log("found players");
        Physics2D.IgnoreLayerCollision(8, 9);
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKeyDown(KeyCode.T))
        {
            Debug.Log("up damage");
            damage = 10;
        }
        if (!isWin)
        {
            if (this.health <= 0)
            {
                Debug.Log("player win, sunny dead");
                isDead = true;
                return;
            }
            timer += Time.deltaTime;
            if (timer < 10)
            {
                subtimer += Time.deltaTime;
                if (subtimer > 1)
                {
                    if(FindClosetPlayer() != null)
                    {
                        this.GetComponent<Rigidbody2D>().AddForce((FindClosetPlayer().transform.position - transform.position).normalized * hardLevel);
                        subtimer = 0;
                    }
                    else
                    {
                        gameoverAnim.SetTrigger("gameOver");
                        isWin = true;
                    }
                }
            }
            else if (timer > 10 && timer < 15)
            {
                subtimer += Time.deltaTime;
                if (subtimer > 1 && subtimer < 2)
                {
                    this.GetComponent<Rigidbody2D>().AddForce(Vector3.down * 100);
                    if (this.transform.position.x <= 0 && count < 1)
                    {
                        Debug.Log(count);
                        count++;
                        this.GetComponent<Rigidbody2D>().AddForce(Vector3.right * 500);
                    }
                    else if (this.transform.position.x > 0 && count < 1)
                    {
                        Debug.Log(count);
                        count++;
                        this.GetComponent<Rigidbody2D>().AddForce(Vector3.left * 500);
                    }
                }
                else if (subtimer > 2 && subtimer < 3)
                {
                    this.GetComponent<Rigidbody2D>().AddForce(Vector3.up * 100);
                    if (this.transform.position.x <= 0 && count < 2)
                    {
                        Debug.Log(count);
                        count++;
                        this.GetComponent<Rigidbody2D>().AddForce(Vector3.right * 500);
                    }
                    if (this.transform.position.x > 0 && count < 2)
                    {
                        Debug.Log(count);
                        count++;
                        this.GetComponent<Rigidbody2D>().AddForce(Vector3.left * 500);
                    }
                }
                else if (subtimer > 3)
                {
                    subtimer = 0;
                    count = 0;
                }
            }
            else if (timer > 15)
            {
                Debug.Log("10");
                timer = 0;
                subtimer = 0;
                count = 0;
            }
        }
    }

    void OnCollisionEnter2D(Collision2D other)
    {
        if (other.gameObject.tag == "Bullet")
        {
            this.health -= damage;
            Destroy(other.gameObject);
            return;
        }
        else if (other.gameObject.tag == "Player1")
        {
            int index = other.transform.GetComponent<PlayerController>().DecreaseHealth();
            if (index != -1)
            {
                players[index] = null;
                if (index == 0) safezoneRandomer.playerW = null;
                else safezoneRandomer.playerM = null;
            }
            Debug.Log(players[0] == null && players[1] == null);
            if(players[0] == null && players[1] == null)
            {
                gameoverAnim.SetTrigger("gameOver");
                isWin = true;
            }
            return;
        }
    }

    public bool IsDead()
    {
        return isDead;
    }
    public void IsWin()
    {
        isWin = true;
    }

    private GameObject FindClosetPlayer()
    {
        if (players[0] == null)
        {
            return players[1];
        }
        else if(players[1] == null)
        {
            return players[0];
        }
        float distP1 = Mathf.Pow(players[0].transform.position.x - this.transform.position.x, 2) + Mathf.Pow(players[0].transform.position.y - this.transform.position.y, 2);
        float distP2 = Mathf.Pow(players[1].transform.position.x - this.transform.position.x, 2) + Mathf.Pow(players[1].transform.position.y - this.transform.position.y, 2);
        if (distP1 > distP2) return players[1];
        return players[0];
    }
}
